diff --git a/sys/kern/subr_autoconf.c b/sys/kern/subr_autoconf.c
index 34499ede31d5..896bacc9a6e0 100644
--- a/sys/kern/subr_autoconf.c
+++ b/sys/kern/subr_autoconf.c
@@ -121,7 +121,7 @@ __KERNEL_RCSID(0, "$NetBSD: subr_autoconf.c,v 1.265 2018/12/01 02:08:16 msaitoh
 /*
  * Device autoconfiguration timings are mixed into the entropy pool.
  */
-extern krndsource_t rnd_autoconf_source;
+krndsource_t rnd_autoconf_source;
 
 /*
  * ioconf.c exports exactly two names: cfdata and cfroots.  All system
@@ -356,6 +356,9 @@ config_init(void)
 	initcftable.ct_cfdata = cfdata;
 	TAILQ_INSERT_TAIL(&allcftables, &initcftable, ct_list);
 
+	rnd_attach_source(&rnd_autoconf_source, "autoconf", RND_TYPE_UNKNOWN,
+	    RND_FLAG_COLLECT_TIME|RND_FLAG_ESTIMATE_TIME);
+
 	config_initialized = true;
 }
 
diff --git a/sys/kern/subr_cprng.c b/sys/kern/subr_cprng.c
index dbd0de925bfe..323b3c13c8eb 100644
--- a/sys/kern/subr_cprng.c
+++ b/sys/kern/subr_cprng.c
@@ -1,11 +1,11 @@
-/*	$NetBSD: subr_cprng.c,v 1.34 2019/12/04 05:36:34 riastradh Exp $ */
+/*	$NetBSD$	*/
 
 /*-
- * Copyright (c) 2011-2013 The NetBSD Foundation, Inc.
+ * Copyright (c) 2019 The NetBSD Foundation, Inc.
  * All rights reserved.
  *
  * This code is derived from software contributed to The NetBSD Foundation
- * by Thor Lancelot Simon and Taylor R. Campbell.
+ * by Taylor R. Campbell.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -29,539 +29,299 @@
  * POSSIBILITY OF SUCH DAMAGE.
  */
 
+/*
+ * cprng_strong
+ *
+ *	Per-CPU NIST Hash_DRBG, reseeded automatically from the entropy
+ *	pool when we transition to full entropy, never blocking.  This
+ *	is slightly different from the old cprng_strong API, but the
+ *	only users of the old one fell into three categories:
+ *
+ *	1. never-blocking, oughta-be-per-CPU (kern_cprng, sysctl_prng)
+ *	2. never-blocking, used per-CPU anyway (/dev/urandom short reads)
+ *	3. /dev/random
+ *
+ *	This code serves the first two categories without having extra
+ *	logic for /dev/random.
+ *
+ *	kern_cprng - available at IPL_VM or lower
+ *	user_cprng - available only at IPL_NONE in thread context
+ *
+ *	The name kern_cprng is for hysterical raisins.  The name
+ *	user_cprng serves only to contrast with kern_cprng.
+ */
+
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: subr_cprng.c,v 1.34 2019/12/04 05:36:34 riastradh Exp $");
+__KERNEL_RCSID(0, "$NetBSD$");
 
-#include <sys/param.h>
 #include <sys/types.h>
-#include <sys/condvar.h>
 #include <sys/cprng.h>
+#include <sys/cpu.h>
+#include <sys/entropy.h>
 #include <sys/errno.h>
-#include <sys/event.h>		/* XXX struct knote */
-#include <sys/fcntl.h>		/* XXX FNONBLOCK */
-#include <sys/kernel.h>
+#include <sys/evcnt.h>
+#include <sys/intr.h>
 #include <sys/kmem.h>
-#include <sys/lwp.h>
-#include <sys/once.h>
 #include <sys/percpu.h>
-#include <sys/poll.h>		/* XXX POLLIN/POLLOUT/&c. */
-#include <sys/select.h>
-#include <sys/systm.h>
 #include <sys/sysctl.h>
-#include <sys/rndsink.h>
+#include <sys/systm.h>
 
 #include <crypto/nist_hash_drbg/nist_hash_drbg.h>
 
-#if defined(__HAVE_CPU_COUNTER)
-#include <machine/cpu_counter.h>
-#endif
+/*
+ * struct cprng_strong
+ */
+struct cprng_strong {
+	struct percpu		*cs_percpu; /* struct cprng_cpu */
+	ipl_cookie_t		cs_iplcookie;
+};
+
+/*
+ * struct cprng_cpu
+ *
+ *	Per-CPU state for a cprng_strong.  The DRBG and evcnt are
+ *	allocated separately because percpu(9) sometimes moves per-CPU
+ *	objects around without zeroing them.
+ */
+struct cprng_cpu {
+	struct nist_hash_drbg	*cc_drbg;
+	struct {
+		struct evcnt	reseed;
+		struct evcnt	intr;
+	}			*cc_evcnt;
+	unsigned		cc_epoch;
+};
 
-static int sysctl_kern_urnd(SYSCTLFN_PROTO);
-static int sysctl_kern_arnd(SYSCTLFN_PROTO);
+static int	sysctl_kern_urandom(SYSCTLFN_ARGS);
+static int	sysctl_kern_arandom(SYSCTLFN_ARGS);
+static void	cprng_init_cpu(void *, void *, struct cpu_info *);
+static void	cprng_fini_cpu(void *, void *, struct cpu_info *);
 
-static void	cprng_strong_generate(struct cprng_strong *, void *, size_t);
-static void	cprng_strong_reseed(struct cprng_strong *);
-static void	cprng_strong_reseed_from(struct cprng_strong *, const void *,
-		    size_t, bool);
+/* Well-known CPRNG instances */
+struct cprng_strong *kern_cprng __read_mostly; /* IPL_VM */
+struct cprng_strong *user_cprng __read_mostly; /* IPL_NONE */
 
-static rndsink_callback_t	cprng_strong_rndsink_callback;
+static struct sysctllog *cprng_sysctllog __read_mostly;
 
 void
 cprng_init(void)
 {
-	static struct sysctllog *random_sysctllog;
 
-	if (nist_hash_drbg_initialize() != 0)
+	if (__predict_false(nist_hash_drbg_initialize() != 0))
 		panic("NIST Hash_DRBG failed self-test");
 
-	sysctl_createv(&random_sysctllog, 0, NULL, NULL,
-		       CTLFLAG_PERMANENT,
-		       CTLTYPE_INT, "urandom",
-		       SYSCTL_DESCR("Random integer value"),
-		       sysctl_kern_urnd, 0, NULL, 0,
-		       CTL_KERN, KERN_URND, CTL_EOL);
-	sysctl_createv(&random_sysctllog, 0, NULL, NULL,
-		       CTLFLAG_PERMANENT,
-		       CTLTYPE_INT, "arandom",
-		       SYSCTL_DESCR("n bytes of random data"),
-		       sysctl_kern_arnd, 0, NULL, 0,
-		       CTL_KERN, KERN_ARND, CTL_EOL);
-}
-
-static inline uint32_t
-cprng_counter(void)
-{
-	struct timeval tv;
-
-#if defined(__HAVE_CPU_COUNTER)
-	if (cpu_hascounter())
-		return cpu_counter32();
-#endif
-	if (__predict_false(cold)) {
-		static int ctr;
-		/* microtime unsafe if clock not running yet */
-		return ctr++;
-	}
-	getmicrotime(&tv);
-	return (tv.tv_sec * 1000000 + tv.tv_usec);
-}
-
-struct cprng_strong {
-	char		cs_name[16];
-	int		cs_flags;
-	kmutex_t	cs_lock;
-	percpu_t	*cs_percpu;
-	kcondvar_t	cs_cv;
-	struct selinfo	cs_selq;
-	struct rndsink	*cs_rndsink;
-	bool		cs_ready;
-	NIST_HASH_DRBG	cs_drbg;
-
-	/* XXX Kludge for /dev/random `information-theoretic' properties.   */
-	unsigned int	cs_remaining;
-};
-
-struct cprng_strong *
-cprng_strong_create(const char *name, int ipl, int flags)
-{
-	const uint32_t cc = cprng_counter();
-	struct cprng_strong *const cprng = kmem_alloc(sizeof(*cprng),
-	    KM_SLEEP);
-
 	/*
-	 * rndsink_request takes a spin lock at IPL_VM, so we can be no
-	 * higher than that.
+	 * Create CPRNG instances at two IPLs: IPL_VM for kernel use
+	 * that may occur inside IPL_VM interrupt handlers (!!??!?!?),
+	 * and IPL_NONE for userland use which need not block
+	 * interrupts.
 	 */
-	KASSERT(ipl != IPL_SCHED && ipl != IPL_HIGH);
-
-	/* Initialize the easy fields.  */
-	memset(cprng->cs_name, 0, sizeof(cprng->cs_name));
-	(void)strlcpy(cprng->cs_name, name, sizeof(cprng->cs_name));
-	cprng->cs_flags = flags;
-	mutex_init(&cprng->cs_lock, MUTEX_DEFAULT, ipl);
-	cv_init(&cprng->cs_cv, cprng->cs_name);
-	selinit(&cprng->cs_selq);
-	cprng->cs_rndsink = rndsink_create(NIST_HASH_DRBG_MIN_SEEDLEN_BYTES,
-	    &cprng_strong_rndsink_callback, cprng);
-
-	/* Get some initial entropy.  Record whether it is full entropy.  */
-	uint8_t seed[NIST_HASH_DRBG_MIN_SEEDLEN_BYTES];
-	mutex_enter(&cprng->cs_lock);
-	cprng->cs_ready = rndsink_request(cprng->cs_rndsink, seed,
-	    sizeof(seed));
-	if (nist_hash_drbg_instantiate(&cprng->cs_drbg, seed, sizeof(seed),
-		&cc, sizeof(cc), cprng->cs_name, sizeof(cprng->cs_name)))
-		/* XXX Fix nist_hash_drbg API so this can't happen.  */
-		panic("cprng %s: NIST Hash_DRBG instantiation failed",
-		    cprng->cs_name);
-	explicit_memset(seed, 0, sizeof(seed));
-
-	if (ISSET(flags, CPRNG_HARD))
-		cprng->cs_remaining = NIST_HASH_DRBG_MIN_SEEDLEN_BYTES;
-	else
-		cprng->cs_remaining = 0;
-
-	if (!cprng->cs_ready && !ISSET(flags, CPRNG_INIT_ANY))
-		printf("cprng %s: creating with partial entropy\n",
-		    cprng->cs_name);
-	mutex_exit(&cprng->cs_lock);
-
-	return cprng;
+	kern_cprng = cprng_strong_create("kern", IPL_VM, 0);
+	user_cprng = cprng_strong_create("user", IPL_NONE, 0);
+
+	/* Create kern.urandom and kern.arandom sysctl nodes.  */
+	sysctl_createv(&cprng_sysctllog, 0, NULL, NULL,
+	    CTLFLAG_PERMANENT|CTLFLAG_READONLY, CTLTYPE_INT, "urandom",
+	    SYSCTL_DESCR("Independent uniform random 32-bit integer"),
+	    sysctl_kern_urandom, 0, NULL, 0, CTL_KERN, KERN_URND, CTL_EOL);
+	sysctl_createv(&cprng_sysctllog, 0, NULL, NULL,
+	    CTLFLAG_PERMANENT|CTLFLAG_READONLY, CTLTYPE_INT /*lie*/, "arandom",
+	    SYSCTL_DESCR("Independent uniform random bytes, up to 256 bytes"),
+	    sysctl_kern_arandom, 0, NULL, 0, CTL_KERN, KERN_ARND, CTL_EOL);
 }
 
-void
-cprng_strong_destroy(struct cprng_strong *cprng)
+/*
+ * sysctl kern.urandom
+ *
+ *	Independent uniform random 32-bit integer.  Read-only.
+ */
+static int
+sysctl_kern_urandom(SYSCTLFN_ARGS)
 {
+	struct sysctlnode node = *rnode;
+	int v;
+	int error;
 
-	/*
-	 * Destroy the rndsink first to prevent calls to the callback.
-	 */
-	rndsink_destroy(cprng->cs_rndsink);
-
-	KASSERT(!cv_has_waiters(&cprng->cs_cv));
-#if 0
-	KASSERT(!select_has_waiters(&cprng->cs_selq)) /* XXX ? */
-#endif
+	/* Generate an int's worth of data.  */
+	cprng_strong(user_cprng, &v, sizeof v, 0);
 
-	nist_hash_drbg_destroy(&cprng->cs_drbg);
-	seldestroy(&cprng->cs_selq);
-	cv_destroy(&cprng->cs_cv);
-	mutex_destroy(&cprng->cs_lock);
+	/* Do the sysctl dance.  */
+	node.sysctl_data = &v;
+	error = sysctl_lookup(SYSCTLFN_CALL(&node));
 
-	explicit_memset(cprng, 0, sizeof(*cprng)); /* paranoia */
-	kmem_free(cprng, sizeof(*cprng));
+	/* Clear the buffer before returning the sysctl error.  */
+	explicit_memset(&v, 0, sizeof v);
+	return error;
 }
 
 /*
- * Generate some data from cprng.  Block or return zero bytes,
- * depending on flags & FNONBLOCK, if cprng was created without
- * CPRNG_REKEY_ANY.
+ * sysctl kern.arandom
+ *
+ *	Independent uniform random bytes, up to 256 bytes.  Read-only.
  */
-size_t
-cprng_strong(struct cprng_strong *cprng, void *buffer, size_t bytes, int flags)
+static int
+sysctl_kern_arandom(SYSCTLFN_ARGS)
 {
-	size_t result;
-
-	/* Caller must loop for more than CPRNG_MAX_LEN bytes.  */
-	bytes = MIN(bytes, CPRNG_MAX_LEN);
-
-	mutex_enter(&cprng->cs_lock);
-
-	if (ISSET(cprng->cs_flags, CPRNG_REKEY_ANY)) {
-		if (!cprng->cs_ready)
-			cprng_strong_reseed(cprng);
-	} else {
-		while (!cprng->cs_ready) {
-			if (ISSET(flags, FNONBLOCK) ||
-			    !ISSET(cprng->cs_flags, CPRNG_USE_CV) ||
-			    cv_wait_sig(&cprng->cs_cv, &cprng->cs_lock)) {
-				result = 0;
-				goto out;
-			}
-		}
-	}
+	struct sysctlnode node = *rnode;
+	uint8_t buf[256];
+	int error;
 
 	/*
-	 * Debit the entropy if requested.
-	 *
-	 * XXX Kludge for /dev/random `information-theoretic' properties.
+	 * Clamp to a reasonably small size.  256 bytes is kind of
+	 * arbitrary; 32 would be more reasonable, but we used 256 in
+	 * the past, so let's not break compatibility.
 	 */
-	if (__predict_false(ISSET(cprng->cs_flags, CPRNG_HARD))) {
-		KASSERT(0 < cprng->cs_remaining);
-		KASSERT(cprng->cs_remaining <=
-		    NIST_HASH_DRBG_MIN_SEEDLEN_BYTES);
-		if (bytes < cprng->cs_remaining) {
-			cprng->cs_remaining -= bytes;
-		} else {
-			bytes = cprng->cs_remaining;
-			cprng->cs_remaining = NIST_HASH_DRBG_MIN_SEEDLEN_BYTES;
-			cprng->cs_ready = false;
-			rndsink_schedule(cprng->cs_rndsink);
-		}
-		KASSERT(bytes <= NIST_HASH_DRBG_MIN_SEEDLEN_BYTES);
-		KASSERT(0 < cprng->cs_remaining);
-		KASSERT(cprng->cs_remaining <=
-		    NIST_HASH_DRBG_MIN_SEEDLEN_BYTES);
-	}
-
-	cprng_strong_generate(cprng, buffer, bytes);
-	result = bytes;
-
-out:	mutex_exit(&cprng->cs_lock);
-	return result;
-}
-
-static void
-filt_cprng_detach(struct knote *kn)
-{
-	struct cprng_strong *const cprng = kn->kn_hook;
-
-	mutex_enter(&cprng->cs_lock);
-	SLIST_REMOVE(&cprng->cs_selq.sel_klist, kn, knote, kn_selnext);
-	mutex_exit(&cprng->cs_lock);
-}
-
-static int
-filt_cprng_read_event(struct knote *kn, long hint)
-{
-	struct cprng_strong *const cprng = kn->kn_hook;
-	int ret;
-
-	if (hint == NOTE_SUBMIT)
-		KASSERT(mutex_owned(&cprng->cs_lock));
-	else
-		mutex_enter(&cprng->cs_lock);
-	if (cprng->cs_ready) {
-		kn->kn_data = CPRNG_MAX_LEN; /* XXX Too large?  */
-		ret = 1;
-	} else {
-		ret = 0;
-	}
-	if (hint == NOTE_SUBMIT)
-		KASSERT(mutex_owned(&cprng->cs_lock));
-	else
-		mutex_exit(&cprng->cs_lock);
-
-	return ret;
-}
-
-static int
-filt_cprng_write_event(struct knote *kn, long hint)
-{
-	struct cprng_strong *const cprng = kn->kn_hook;
-
-	if (hint == NOTE_SUBMIT)
-		KASSERT(mutex_owned(&cprng->cs_lock));
-	else
-		mutex_enter(&cprng->cs_lock);
+	if (*oldlenp > 256)	/* size_t, so never negative */
+		return E2BIG;
 
-	kn->kn_data = 0;
+	/* Generate data.  */
+	cprng_strong(user_cprng, buf, *oldlenp, 0);
 
-	if (hint == NOTE_SUBMIT)
-		KASSERT(mutex_owned(&cprng->cs_lock));
-	else
-		mutex_exit(&cprng->cs_lock);
+	/* Do the sysctl dance.  */
+	node.sysctl_data = buf;
+	node.sysctl_size = *oldlenp;
+	error = sysctl_lookup(SYSCTLFN_CALL(&node));
 
-	return 0;
+	/* Clear the buffer before returning the sysctl error.  */
+	explicit_memset(buf, 0, sizeof buf);
+	return error;
 }
 
-static const struct filterops cprng_read_filtops = {
-	.f_isfd = 1,
-	.f_attach = NULL,
-	.f_detach = filt_cprng_detach,
-	.f_event = filt_cprng_read_event,
-};
-
-static const struct filterops cprng_write_filtops = {
-	.f_isfd = 1,
-	.f_attach = NULL,
-	.f_detach = filt_cprng_detach,
-	.f_event = filt_cprng_write_event,
-};
-
-int
-cprng_strong_kqfilter(struct cprng_strong *cprng, struct knote *kn)
-{
-
-	switch (kn->kn_filter) {
-	case EVFILT_READ:
-		kn->kn_fop = &cprng_read_filtops;
-		break;
-	case EVFILT_WRITE:
-		kn->kn_fop = &cprng_write_filtops;
-		break;
-	default:
-		return EINVAL;
-	}
-
-	kn->kn_hook = cprng;
-	mutex_enter(&cprng->cs_lock);
-	SLIST_INSERT_HEAD(&cprng->cs_selq.sel_klist, kn, kn_selnext);
-	mutex_exit(&cprng->cs_lock);
-	return 0;
-}
-
-int
-cprng_strong_poll(struct cprng_strong *cprng, int events)
+struct cprng_strong *
+cprng_strong_create(const char *name, int ipl, int flags)
 {
-	int revents;
-
-	if (!ISSET(events, (POLLIN | POLLRDNORM)))
-		return 0;
-
-	mutex_enter(&cprng->cs_lock);
-	if (cprng->cs_ready) {
-		revents = (events & (POLLIN | POLLRDNORM));
-	} else {
-		selrecord(curlwp, &cprng->cs_selq);
-		revents = 0;
-	}
-	mutex_exit(&cprng->cs_lock);
+	struct cprng_strong *cprng;
 
-	return revents;
-}
+	cprng = kmem_alloc(sizeof(*cprng), KM_SLEEP);
+	cprng->cs_percpu = percpu_alloc(sizeof(struct cprng_cpu));
+	cprng->cs_iplcookie = makeiplcookie(ipl);
+	percpu_foreach(cprng->cs_percpu, cprng_init_cpu, __UNCONST(name));
 
-/*
- * XXX Move nist_hash_drbg_reseed_advised_p and
- * nist_hash_drbg_reseed_needed_p into the nist_hash_drbg API and make
- * the NIST_HASH_DRBG structure opaque.
- */
-static bool
-nist_hash_drbg_reseed_advised_p(NIST_HASH_DRBG *drbg)
-{
-
-	return (drbg->reseed_counter > (NIST_HASH_DRBG_RESEED_INTERVAL / 2));
+	return cprng;
 }
 
-static bool
-nist_hash_drbg_reseed_needed_p(NIST_HASH_DRBG *drbg)
+void
+cprng_strong_destroy(struct cprng_strong *cprng)
 {
 
-	return (drbg->reseed_counter >= NIST_HASH_DRBG_RESEED_INTERVAL);
+	percpu_foreach(cprng->cs_percpu, cprng_fini_cpu, NULL);
+	percpu_free(cprng->cs_percpu, sizeof(struct cprng_cpu));
+	kmem_free(cprng, sizeof(*cprng));
 }
 
-/*
- * Generate some data from the underlying generator.
- */
 static void
-cprng_strong_generate(struct cprng_strong *cprng, void *buffer, size_t bytes)
+cprng_init_cpu(void *ptr, void *cookie, struct cpu_info *ci)
 {
-	const uint32_t cc = cprng_counter();
-
-	KASSERT(bytes <= CPRNG_MAX_LEN);
-	KASSERT(mutex_owned(&cprng->cs_lock));
+	struct cprng_cpu *cc = ptr;
+	const char *name = cookie;
+	uint8_t zero[NIST_HASH_DRBG_SEEDLEN_BYTES] = {0};
+	char namebuf[64];	/* XXX size? */
 
 	/*
-	 * Generate some data from the NIST Hash_DRBG.  Caller
-	 * guarantees reseed if we're not ready, and if we exhaust the
-	 * generator, we mark ourselves not ready.  Consequently, this
-	 * call to the Hash_DRBG should not fail.
+	 * Format the name as, e.g., kern/8 if we're on cpu8.  This
+	 * doesn't get displayed anywhere; it just ensures that if
+	 * there were a bug causing us to use the same otherwise secure
+	 * seed on multiple CPUs, we would still get independent output
+	 * from the NIST Hash_DRBG.
 	 */
-	if (__predict_false(nist_hash_drbg_generate(&cprng->cs_drbg, buffer,
-		    bytes, &cc, sizeof(cc))))
-		panic("cprng %s: NIST Hash_DRBG failed", cprng->cs_name);
+	snprintf(namebuf, sizeof namebuf, "%s/%u", name, cpu_index(ci));
 
 	/*
-	 * If we've been seeing a lot of use, ask for some fresh
-	 * entropy soon.
+	 * Allocate the struct nist_hash_drbg and struct evcnt
+	 * separately, since percpu(9) may move objects around in
+	 * memory without zeroing.
 	 */
-	if (__predict_false(nist_hash_drbg_reseed_advised_p(&cprng->cs_drbg)))
-		rndsink_schedule(cprng->cs_rndsink);
+	cc->cc_drbg = kmem_zalloc(sizeof(*cc->cc_drbg), KM_SLEEP);
+	cc->cc_evcnt = kmem_alloc(sizeof(*cc->cc_evcnt), KM_SLEEP);
 
 	/*
-	 * If we just exhausted the generator, inform the next user
-	 * that we need a reseed.
+	 * Initialize the DRBG with no seed.  We do this in order to
+	 * defer reading from the entropy pool as long as possible.
 	 */
-	if (__predict_false(nist_hash_drbg_reseed_needed_p(&cprng->cs_drbg))) {
-		cprng->cs_ready = false;
-		rndsink_schedule(cprng->cs_rndsink); /* paranoia */
-	}
+	if (__predict_false(nist_hash_drbg_instantiate(cc->cc_drbg,
+		    zero, sizeof zero, NULL, 0, namebuf, strlen(namebuf))))
+		panic("nist_hash_drbg_instantiate");
+
+	/* Attach the event counters.  */
+	evcnt_attach_dynamic(&cc->cc_evcnt->intr, EVCNT_TYPE_MISC, NULL,
+	    ci->ci_cpuname, "cprng_strong intr");
+	evcnt_attach_dynamic(&cc->cc_evcnt->reseed, EVCNT_TYPE_MISC, NULL,
+	    ci->ci_cpuname, "cprng_strong reseed");
+
+	/* Set the epoch uninitialized so we reseed on first use.  */
+	cc->cc_epoch = 0;
 }
 
-/*
- * Reseed with whatever we can get from the system entropy pool right now.
- */
 static void
-cprng_strong_reseed(struct cprng_strong *cprng)
+cprng_fini_cpu(void *ptr, void *cookie, struct cpu_info *ci)
 {
-	uint8_t seed[NIST_HASH_DRBG_MIN_SEEDLEN_BYTES];
+	struct cprng_cpu *cc = ptr;
 
-	KASSERT(mutex_owned(&cprng->cs_lock));
+	evcnt_detach(&cc->cc_evcnt->reseed);
+	evcnt_detach(&cc->cc_evcnt->intr);
+	if (__predict_false(nist_hash_drbg_destroy(cc->cc_drbg)))
+		panic("nist_hash_drbg_destroy");
 
-	const bool full_entropy = rndsink_request(cprng->cs_rndsink, seed,
-	    sizeof(seed));
-	cprng_strong_reseed_from(cprng, seed, sizeof(seed), full_entropy);
-	explicit_memset(seed, 0, sizeof(seed));
+	kmem_free(cc->cc_evcnt, sizeof(*cc->cc_evcnt));
+	kmem_free(cc->cc_drbg, sizeof(*cc->cc_drbg));
 }
 
-/*
- * Reseed with the given seed.  If we now have full entropy, notify waiters.
- */
-static void
-cprng_strong_reseed_from(struct cprng_strong *cprng,
-    const void *seed, size_t bytes, bool full_entropy)
+size_t
+cprng_strong(struct cprng_strong *cprng, void *buf, size_t len, int flags)
 {
-	const uint32_t cc = cprng_counter();
-
-	KASSERT(bytes == NIST_HASH_DRBG_MIN_SEEDLEN_BYTES);
-	KASSERT(mutex_owned(&cprng->cs_lock));
+	uint32_t seed[NIST_HASH_DRBG_SEEDLEN_BYTES];
+	struct cprng_cpu *cc;
+	unsigned epoch;
+	int s;
 
 	/*
-	 * Notify anyone interested in the partiality of entropy in our
-	 * seed -- anyone waiting for full entropy, or any system
-	 * operators interested in knowing when the entropy pool is
-	 * running on fumes.
+	 * Verify maximum request length.  Caller should really limit
+	 * their requests to 32 bytes to avoid spending much time with
+	 * preemption disabled -- use the 32 bytes to seed a private
+	 * DRBG instance if you need more data.
 	 */
-	if (full_entropy) {
-		if (!cprng->cs_ready) {
-			cprng->cs_ready = true;
-			cv_broadcast(&cprng->cs_cv);
-			selnotify(&cprng->cs_selq, (POLLIN | POLLRDNORM),
-			    NOTE_SUBMIT);
-		}
-	} else {
-		/*
-		 * XXX Is there is any harm in reseeding with partial
-		 * entropy when we had full entropy before?  If so,
-		 * remove the conditional on this message.
-		 */
-		if (!cprng->cs_ready &&
-		    !ISSET(cprng->cs_flags, CPRNG_REKEY_ANY))
-			printf("cprng %s: reseeding with partial entropy\n",
-			    cprng->cs_name);
+	KASSERT(len <= CPRNG_MAX_LEN);
+
+	/* Verify legacy API use.  */
+	KASSERT(flags == 0);
+
+	/* Acquire per-CPU state and block interrupts.  */
+	cc = percpu_getref(cprng->cs_percpu);
+	s = splraiseipl(cprng->cs_iplcookie);
+
+	if (cpu_intr_p())
+		cc->cc_evcnt->intr.ev_count++;
+
+	/* If the entropy epoch has changed, (re)seed.  */
+	epoch = entropy_epoch();
+	if (__predict_false(epoch != cc->cc_epoch)) {
+		entropy_extract(seed, sizeof seed, 0);
+		cc->cc_evcnt->reseed.ev_count++;
+		if (__predict_false(nist_hash_drbg_reseed(cc->cc_drbg,
+			    seed, sizeof seed, NULL, 0)))
+			panic("nist_hash_drbg_reseed");
+		explicit_memset(seed, 0, sizeof seed);
+		cc->cc_epoch = epoch;
 	}
 
-	if (nist_hash_drbg_reseed(&cprng->cs_drbg, seed, bytes, &cc,
-		sizeof(cc)))
-		/* XXX Fix nist_hash_drbg API so this can't happen.  */
-		panic("cprng %s: NIST Hash_DRBG reseed failed",
-		    cprng->cs_name);
-}
-
-/*
- * Feed entropy from an rndsink request into the CPRNG for which the
- * request was issued.
- */
-static void
-cprng_strong_rndsink_callback(void *context, const void *seed, size_t bytes)
-{
-	struct cprng_strong *const cprng = context;
-
-	mutex_enter(&cprng->cs_lock);
-	/* Assume that rndsinks provide only full-entropy output.  */
-	cprng_strong_reseed_from(cprng, seed, bytes, true);
-	mutex_exit(&cprng->cs_lock);
-}
-
-static ONCE_DECL(sysctl_prng_once);
-static cprng_strong_t *sysctl_prng;
-
-static int
-makeprng(void)
-{
-
-	/* can't create in cprng_init(), too early */
-	sysctl_prng = cprng_strong_create("sysctl", IPL_NONE,
-					  CPRNG_INIT_ANY|CPRNG_REKEY_ANY);
-	return 0;
-}
-
-/*
- * sysctl helper routine for kern.urandom node. Picks a random number
- * for you.
- */
-static int
-sysctl_kern_urnd(SYSCTLFN_ARGS)
-{
-	int v, rv;
-
-	RUN_ONCE(&sysctl_prng_once, makeprng);
-	rv = cprng_strong(sysctl_prng, &v, sizeof(v), 0);
-	if (rv == sizeof(v)) {
-		struct sysctlnode node = *rnode;
-		node.sysctl_data = &v;
-		return (sysctl_lookup(SYSCTLFN_CALL(&node)));
+	/* Generate data.  Failure here means it's time to reseed.  */
+	if (__predict_false(nist_hash_drbg_generate(cc->cc_drbg, buf, len,
+		    NULL, 0))) {
+		entropy_extract(seed, sizeof seed, 0);
+		cc->cc_evcnt->reseed.ev_count++;
+		if (__predict_false(nist_hash_drbg_reseed(cc->cc_drbg,
+			    seed, sizeof seed, NULL, 0)))
+			panic("nist_hash_drbg_reseed");
+		explicit_memset(seed, 0, sizeof seed);
+		if (__predict_false(nist_hash_drbg_generate(cc->cc_drbg,
+			    buf, len, NULL, 0)))
+			panic("nist_hash_drbg_generate");
 	}
-	else
-		return (EIO);	/*XXX*/
-}
 
-/*
- * sysctl helper routine for kern.arandom node.  Fills the supplied
- * structure with random data for you.
- *
- * This node was originally declared as type "int" but its implementation
- * in OpenBSD, whence it came, would happily return up to 8K of data if
- * requested.  Evidently this was used to key RC4 in userspace.
- *
- * In NetBSD, the libc stack-smash-protection code reads 64 bytes
- * from here at every program startup.  Third-party software also often
- * uses this to obtain a key for CSPRNG, reading 32 bytes or more, while
- * avoiding the need to open /dev/urandom.
- */
-static int
-sysctl_kern_arnd(SYSCTLFN_ARGS)
-{
-	int error;
-	void *v;
-	struct sysctlnode node = *rnode;
-	size_t n __diagused;
-
-	switch (*oldlenp) {
-	    case 0:
-		return 0;
-	    default:
-		if (*oldlenp > 256) {
-			return E2BIG;
-		}
-		RUN_ONCE(&sysctl_prng_once, makeprng);
-		v = kmem_alloc(*oldlenp, KM_SLEEP);
-		n = cprng_strong(sysctl_prng, v, *oldlenp, 0);
-		KASSERT(n == *oldlenp);
-		node.sysctl_data = v;
-		node.sysctl_size = *oldlenp;
-		error = sysctl_lookup(SYSCTLFN_CALL(&node));
-		kmem_free(v, *oldlenp);
-		return error;
-	}
+	/* Release state and interrupts.  */
+	splx(s);
+	percpu_putref(cprng->cs_percpu);
+
+	/* Return the number of bytes generated, for hysterical raisins.  */
+	return len;
 }
diff --git a/sys/kern/subr_rngtest.c b/sys/kern/subr_rngtest.c
new file mode 100644
index 000000000000..07956556e50b
--- /dev/null
+++ b/sys/kern/subr_rngtest.c
@@ -0,0 +1,212 @@
+/*	$NetBSD$	*/
+
+/*-
+ * Copyright (c) 2019 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+ * NIST SP800-90B 4.4.1 repetition count test, restricted to two
+ * samples of output.
+ *
+ * Driver:
+ *
+ *	xyz_attach(sc)
+ *	{
+ *		...
+ *		// 100 bits of data to get each bit of entropy
+ *		sc->sc_rngtest = rngreptest_create(&sc->sc_rndsource, 100);
+ *		rnd_attach_source(&sc->sc_rndsource, ...);
+ *	}
+ *
+ *	xyz_intr(sc)
+ *	{
+ *		buf = sc->sc_intrbuf;
+ *		len = READ4(sc, XYZ_NBYTES_READY);
+ *
+ *		rngreptest_feed(&sc->sc_rndsource, buf, len);
+ *	}
+ */
+
+#include <sys/cdefs.h>
+__KERNEL_RCSID(0, "$NetBSD$");
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/bitops.h>
+#include <sys/kmem.h>
+#include <sys/rndsource.h>
+#include <sys/rngtest.h>
+
+#include <machine/limits.h>
+
+struct rngreptest {
+	struct krndsource	*rndsource;
+	unsigned		entropyrate; /* min #bits per bit of entropy */
+	unsigned		m; /* division by entropyrate */
+	uint8_t			s1, s2;
+	unsigned		i, N;
+	uint8_t			buf[/*N*/];
+};
+
+/*
+ * Arbitrarily limit us to two pages (or one page, on 8K-page
+ * machines).  Anything more than this is getting excessive and
+ * suggests you should maybe reconsider the RNG or at least the test.
+ */
+CTASSERT(sizeof(struct rngreptest) <= 8192u);
+#define	MAXBUF	(8192u - sizeof(struct rngreptest))
+
+struct rngreptest *
+rngreptest_create(struct krndsource *rndsource, unsigned entropyrate)
+{
+	unsigned N;
+	struct rngreptest *T;
+
+	/*
+	 * Require the entropy to be good enough that a sample MAXBUF
+	 * bytes long has at least two samples with 256 bits of entropy
+	 * apiece.  If not, maybe you should use a different test.
+	 */
+	if (entropyrate > MAXBUF/256/2)
+		panic("%u bits of data per bit of entropy is too many",
+		    entropyrate);
+
+	N = entropyrate * 256 * 2;
+	T = kmem_alloc(offsetof(struct rngreptest, buf[N]), KM_SLEEP);
+
+	T->rndsource = rndsource;
+	T->entropyrate = entropyrate;
+	fast_divide32_prepare(entropyrate, &T->m, &T->s1, &T->s2);
+	T->i = 0;
+	T->N = N;
+
+	return T;
+}
+
+void
+rngreptest_destroy(struct rngreptest *T)
+{
+
+	explicit_memset(T, 0, offsetof(struct rngreptest, buf[T->N]));
+	kmem_free(T, offsetof(struct rngreptest, buf[T->N]));
+}
+
+static unsigned
+rngreptest_entropybits(struct rngreptest *T, uint32_t nbytes)
+{
+	uint32_t nbits;
+
+	if (rndsource_disabled(T->rndsource))
+		return 0;
+	nbits = MIN(nbytes, UINT32_MAX/NBBY)*NBBY;
+	return fast_divide32(nbits, T->entropyrate, T->m, T->s1, T->s2);
+}
+
+static void
+rngreptest_feed_1(struct rngreptest *T, const void *buf, uint32_t len)
+{
+	unsigned entropybits = rngreptest_entropybits(T, len);
+
+	rnd_add_data(T->rndsource, buf, len, entropybits);
+}
+
+static void
+rngreptest_busted(struct rngreptest *T)
+{
+
+	rndsource_disable(T->rndsource);
+	printf("entropy source `%s' failed repeated-output test"
+	    " with false alarm rate 1/2^256\n",
+	    rndsource_name(T->rndsource));
+}
+
+void
+rngreptest_feed(struct rngreptest *T, const void *buf, uint32_t len)
+{
+	const unsigned N = T->N;
+	const uint8_t *p = buf;
+	uint32_t n = len;
+
+	/* If T->buf is partially filled, finish filling it first.  */
+	if (T->i) {
+		memcpy(T->buf + T->i, p, MIN(n, N - T->i));
+		T->i += MIN(n, N - T->i);
+		p += MIN(n, N - T->i);
+		n -= MIN(n, N - T->i);
+
+		/* If we didn't fill up T->buf, we're done.  */
+		if (T->i < N) {
+			KASSERT(n == 0);
+			goto out;
+		}
+
+		/*
+		 * Test the first buffered half against the second
+		 * buffered half, and feed the first buffered half in.
+		 */
+		if (consttime_memequal(T->buf, T->buf + N/2, N/2))
+			rngreptest_busted(T);
+		rngreptest_feed_1(T, T->buf, N/2);
+
+		/* If we can't fill another half, save it and stop.  */
+		if (n < N/2) {
+			memcpy(T->buf, T->buf + N/2, N/2);
+			memcpy(T->buf + N/2, p, n);
+			explicit_memset(T->buf + N/2 + n, 0, N/2 - n);
+			T->i = N/2 + n;
+			goto out;
+		}
+
+		/*
+		 * Otherwise, test the second buffered half against p/n
+		 * and then start feeding it in.
+		 */
+		if (consttime_memequal(T->buf + N/2, p, n))
+			rngreptest_busted(T);
+		rngreptest_feed_1(T, T->buf + N/2, N/2);
+		explicit_memset(T->buf, 0, N);
+		T->i = 0;
+	}
+
+	KASSERT(T->i == 0);
+
+	/* Munch through the input one buffer's worth at a time.  */
+	while (n >= N) {
+		if (consttime_memequal(p, p + N/2, N/2))
+			rngreptest_busted(T);
+		rngreptest_feed_1(T, p, N/2);
+		p += N/2;
+		n -= N/2;
+	}
+
+	/* Save the remainder if any in the buffer.  */
+	memcpy(T->buf, p, n);
+	T->i = n;
+
+out:	KASSERT(T->i < N);
+}
diff --git a/sys/lib/libkern/Makefile.libkern b/sys/lib/libkern/Makefile.libkern
index b2296a8a13db..0e2f4cd257e0 100644
--- a/sys/lib/libkern/Makefile.libkern
+++ b/sys/lib/libkern/Makefile.libkern
@@ -35,6 +35,7 @@ CPPFLAGS+=	-I$M ${KERNCPPFLAGS} ${KERNMISCCPPFLAGS}
 .include "${.PARSEDIR}/../../../common/lib/libppath/Makefile.inc"
 
 CPPFLAGS+=	-I${KERNDIR}/../../../common/include
+CPPFLAGS+=	-I${KERNDIR}/../../../common/libc/hash/sha3
 
 .PATH.c: ${KERNDIR}
 .if exists ($M/Makefile.inc)
@@ -94,6 +95,8 @@ SRCS+=	hexdump.c
 # for crypto
 SRCS+=	explicit_memset.c consttime_memequal.c
 
+SRCS+=	entpool.c
+
 .PATH:	${NETBSDSRCDIR}/common/lib/libc/cdb
 SRCS+=	cdbr.c
 SRCS+=	mi_vector_hash.c
